%if 0%{?openeuler}
%bcond_without python2
%bcond_without python3
%endif

%define dictdir %{_datadir}/cracklib
%define dictpath %{dictdir}/pw_dict

Name: cracklib
Version: 2.9.7
Release: 6%{?dist}.05
Summary: A password-checking library

License: LGPLv2+
URL: http://sourceforge.net/projects/cracklib/
Source0: https://github.com/cracklib/cracklib/releases/download/cracklib-%{version}/cracklib-%{version}.tar.gz
Source1: https://github.com/cracklib/cracklib/releases/download/cracklib-%{version}/cracklib-words-%{version}.gz

# From attachment to https://bugzilla.redhat.com/show_bug.cgi?id=627449
Source3: cracklib.default.zh_CN.po

# No upstream source for this, just words missing from the current cracklib-words
Source10: missing-words.gz

Patch0: fix-problem-of-error-message-about-simplistic-passwo.patch
Patch1: backport-cracklib-2.9.6-lookup.patch
Patch2: cracklib-2.9.1-inttypes.patch
Patch3: cracklib-2.9.0-python-gzdicts.patch
# After fix-problem-of-error-message-about-simplistic-passwo.patch
Patch6: fix-error-length-about-simplistic-password.patch
Patch7: fix-truncating-dict-file-without-input-data.patch

BuildRequires: gcc, words, gettext, gettext-autopoint, zlib-devel
%if %{with python2}
BuildRequires: python2-devel
%endif
%if %{with python3}
BuildRequires: python3-devel
%endif
Conflicts: cracklib-dicts < 2.8
Requires: gzip

%if 0%{?openeuler}
Provides: cracklib-dicts
Provides: %{name}-python = %{version}-%{release}
Provides: %{name}-python%{?_isa} = %{version}-%{release}
Obsoletes: cracklib-dicts
Obsoletes: %{name}-python < %{version}-%{release}
%else
Requires: bash
Requires: glibc
Provides: /usr/sbin/cracklib-check
Provides: /usr/sbin/cracklib-format
Provides: /usr/sbin/cracklib-packer
Provides: /usr/sbin/cracklib-unpacker
Provides: /usr/sbin/create-cracklib-dict
%endif


%description
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics, with the purpose of preventing users
from choosing passwords that could easily be guessed.

CrackLib is a library containing a C function which may be used in a
"passwd"-like program. If you install CrackLib, you will also want to
install the cracklib-dicts package.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}-%{release}

%description devel
The cracklib-devel package contains the header files and libraries needed
for compiling applications which use cracklib.

%if 0%{?openeuler}
%package_help
%else
%package dicts
Summary: The standard CrackLib dictionaries
Group: System Environment/Libraries
BuildRequires: words >= 2-13
Requires: cracklib = %{version}-%{release}

%description dicts
The cracklib-dicts package includes the CrackLib dictionaries.
CrackLib will need to use the dictionary appropriate to your system,
which is normally put in /usr/share/dict/words. Cracklib-dicts also
contains the utilities necessary for the creation of new dictionaries.

If you are installing CrackLib, you should also install cracklib-dicts.

%package doc
Summary: Documents for %{name}
BuildArch: noarch
Requires: %{name} = %{version}-%{release}

%description doc
Doc pages for %{name}.

%endif

%if %{with python2}
%package -n python2-cracklib
Summary: Python 2 bindings for applications which use cracklib
Requires: %{name} = %{version}-%{release}

%description -n python2-cracklib
The python2-cracklib package contains a module which permits applications
written in the Python 2 programming language to use cracklib.
%endif

%if %{with python3}
%package -n python3-cracklib
Summary: Python 3 bindings for applications which use cracklib
Requires: %{name} = %{version}-%{release}

%description -n python3-cracklib
The python3-cracklib package contains a module which permits applications
written in the Python 3 programming language to use cracklib.
%endif

%prep
%autosetup -n %{name}-%{version} -p1
install -p -m 644 %{SOURCE3} po/zh_CN.po

mkdir cracklib-dicts
for dict in %{SOURCE10} %{SOURCE1}
do
        cp -fv ${dict} cracklib-dicts/
done
chmod +x util/cracklib-format

%if %{with python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif

%build
%if %{with python2} || 0%{?rhel} >= 8
sed -i 's,util/cracklib-check <,util/cracklib-check $(DESTDIR)/$(DEFAULT_CRACKLIB_DICT) <,' Makefile.in
export PYTHON=%{__python2}
%configure \
    --disable-static \
    --with-pic \
%if 0%{?openeuler}
    --with-python \
%else
    --without-python \
%endif
    --with-default-dict=%{dictpath}
make -C po update-gmo
make
%endif

%if %{with python3}
pushd %{py3dir}
sed -i 's,util/cracklib-check <,util/cracklib-check $(DESTDIR)/$(DEFAULT_CRACKLIB_DICT) <,' Makefile.in
py3include=`python3-config --includes | awk -F' ' '{print $1;}'`
export PYTHON=%{__python3}
export CFLAGS="%{optflags} $py3include"
abiflags=`python3-config --abiflags`
py_version="%{python3_version}$abiflags"
%configure \
    am_cv_python_version="$py_version" \
    --disable-static \
    --with-pic \
    --with-python \
    --with-default-dict=%{dictpath}
make -C po update-gmo
make
popd
%endif

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%if %{with python2} || 0%{?rhel} >= 8
make install DESTDIR=$RPM_BUILD_ROOT 'pythondir=${pyexecdir}'
%endif

%if %{with python3}
pushd %{py3dir}
make install DESTDIR=$RPM_BUILD_ROOT 'pythondir=${pyexecdir}'
popd
%endif

./util/cracklib-format cracklib-dicts/* | \
./util/cracklib-packer $RPM_BUILD_ROOT/%{dictpath}
./util/cracklib-format $RPM_BUILD_ROOT/%{dictdir}/cracklib-small | \
./util/cracklib-packer $RPM_BUILD_ROOT/%{dictdir}/cracklib-small
rm -f $RPM_BUILD_ROOT/%{dictdir}/cracklib-small
sed s,/usr/lib/cracklib_dict,%{dictpath},g lib/crack.h > $RPM_BUILD_ROOT/%{_includedir}/crack.h
ln -s cracklib-format $RPM_BUILD_ROOT/%{_sbindir}/mkdict
ln -s cracklib-packer $RPM_BUILD_ROOT/%{_sbindir}/packer
touch $RPM_BUILD_ROOT/top
 
toprelpath=..
touch $RPM_BUILD_ROOT/top
while ! test -f $RPM_BUILD_ROOT/%{_libdir}/$toprelpath/top ; do
	toprelpath=../$toprelpath
done
rm -f $RPM_BUILD_ROOT/top
if test %{dictpath} != %{_libdir}/cracklib_dict ; then
ln -s $toprelpath%{dictpath}.hwm $RPM_BUILD_ROOT/%{_libdir}/cracklib_dict.hwm
ln -s $toprelpath%{dictpath}.pwd $RPM_BUILD_ROOT/%{_libdir}/cracklib_dict.pwd
ln -s $toprelpath%{dictpath}.pwi $RPM_BUILD_ROOT/%{_libdir}/cracklib_dict.pwi
fi
rm -f $RPM_BUILD_ROOT/%{_libdir}/python*/site-packages/_cracklib*.*a
rm -f $RPM_BUILD_ROOT/%{_libdir}/libcrack.la
 
%find_lang %{name}

%check
make test

%ldconfig_scriptlets

%files -f %{name}.lang
%defattr(-,root,root)
%license COPYING.LIB
%{_sbindir}/*cracklib*
%{_libdir}/libcrack.so.*
%dir %{_datadir}/cracklib
%{_datadir}/cracklib/cracklib.magic
%if 0%{?openeuler}
%{_sbindir}/mkdict
%{_sbindir}/packer
%{_libdir}/cracklib_dict.*
%config(noreplace) %{_datadir}/cracklib/pw_dict.*
%{_datadir}/cracklib/cracklib-small.*
%doc README-LICENSE AUTHORS
%endif

%files devel
%{_includedir}/*
%{_libdir}/libcrack.so

%if 0%{?openeuler}
%files help
%doc README README-WORDS NEWS
%else

%files dicts
%config(noreplace) %{_datadir}/cracklib/pw_dict.*
%{_datadir}/cracklib/cracklib-small.*
%{_libdir}/cracklib_dict.*
%{_sbindir}/mkdict
%{_sbindir}/packer

%files doc
%doc README README-WORDS NEWS README-LICENSE AUTHORS
%endif

%if %{with python2}
%files -n python2-cracklib
%{_libdir}/python2*/site-packages/_cracklib*.so
%{_libdir}/python2*/site-packages/*.py*
%endif

%if %{with python3}
%files -n python3-cracklib
%{_libdir}/python3*/site-packages/_cracklib*.so
%{_libdir}/python3*/site-packages/*.py*
%{_libdir}/python3*/site-packages/__pycache__/*
%endif

%changelog
* Tue Nov 01 2022 maqi <maqi@uniontech.com> - 2.9.7-6.05
- fix: Add %%config(noreplace) for pw_dict(bugid:168659)

* Tue Oct 18 2022 haomimi <haomimi@uniontech.com> - 2.9.7-6.04
- Add doc sub package

* Thu Sep 08 2022 wangqia <wangqia@uniontech.com> - 2.9.7-6.03
- fix Segment error (core dumped)

* Wed Sep 07 2022 wangqia <wangqia@uniontech.com> - 2.9.7-6.02
- update:update for uniontech

* Wed Aug 24 2022 wangqia <wangqia@uniontech.com> - 2.9.7-6.01
- fix issue of truncating dict file without input data
- fix error length about simplistic password

* Tue Aug 09 2022 wangqia <wangqia@uniontech.com> - 2.9.7-5.01
- update:update for uniontech

* Mon Dec 6 2021 yixiangzhike <yixiangzhike007@163.com> - 2.9.7-5
- Fix lookup for word in FindPW()

* Mon May 17 2021 yixiangzhike <zhangxingliang3@huawei.com> - 2.9.7-4
- Add %%config(noreplace) for pw_dict

* Mon Sep 7 2020 zhangxingliang <zhangxingliang3@huawei.com> - 2.9.7-3
- Add python3-cracklib package

* Sat Jan 18 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.9.7-2
- fix problem of error message about simplistic password

* Fri Jan 10 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.9.7-1
- clean code

* Fri Sep 27 2019 openEuler Buildteam <buildteam@openeuler.org> - 2.9.6-17
- Add python2-cracklib package

* Fri Sep 20 2019 openEuler Buildteam <buildteam@openeuler.org> - 2.9.6-16
- Package init
